#ifndef DIFFICULTY_H
#define DIFFICULTY_H

#include <types.h>
#include "GameState.h"
#include "MapManager.h"

// Game difficulty options.
#define EASY_DIFFICULTY 0
#define NORMAL_DIFFICULTY 1
#define HARD_DIFFICULTY 2

// The difficulty level chosen by the player for the game.
extern u8 chosenDifficulty;

// The number of historical structures that are allowed to be destroyed without the player losing the game.
extern u8 allowedDestroyedStructures;

// The number of non player ships that are allowed to be destroyed without the player losing the game.
extern u8 allowedDestroyedShips;

// The number of turtles that are allowed to be destroyed without the player losing the game.
extern u8 allowedKilledTurtles;

// Sets up the difficulty values based on the chosen difficulty.
void setupDifficulty();

#endif