#ifndef GAME_H
#define GAME_H

#include <cpctelera.h>
#include "Dialog.h"
#include "GameState.h"
#include "GameTypes.h"
#include "Help.h"
#include "Hud.h"
#include "Keys.h"
#include "Link.h"
#include "Map.h"
#include "MapScreen.h"
#include "Mine.h"
#include "Objectives.h"
#include "Player.h"
#include "Scrolling.h"
#include "Ship.h"
#include "Unit.h"
#include "UnitSelection.h"
#include "sound/Effects.h"

// Displays the contents of the game on the screen as it changes.
void drawGame();

// This is where the processing of all the game logic happens.
void gameLogic();

// Any setup required before the game can start.
void initGame();

// Read input from the player.
void readInput();

// Runs the game and the game loop.
void runGame();

// Runs the full game session and manages the levels in the game.
void runGameSession();

#endif