#include "Help.h"

#define TITLE_X_ 10
#define TITLE_Y_ 10

#define OBJECTIVES_X_ 10
#define OBJECTIVES_Y_0 50
#define OBJECTIVES_Y_1 60
#define OBJECTIVES_Y_2 70
#define OBJECTIVES_Y_3 80

#define GRAPHIC_Y_ 30

const u8 CLEAR_MINES_TEXT[20] = "clear all the mines";
const u8 TURTLES_SAFE_TEXT[23] = "keep the turtles safe";
const u8 SHIPS_SAFE_TEXT[20] = "keep the ships safe";
const u8 STRUCTURES_SAFE_TEXT[25] = "keep the structures safe";
const u8 RESCUE_CARGO_TEXT[17] = "rescue the cargo";
const u8 LEVEL_INFORMATION_TEXT[18] = "level information";
const u8 OBJECTIVE_TEXT[11] = "objectives";
const u8 TIME_LIMIT_TEXT[23] = "finish within the time";

const u8 LEVEL_WILDLIFE_TEXT[19] = "wildlife sanctuary";
const u8 LEVEL_GATED_TRADELANE_TEXT[17] = "gated trade lane";
const u8 LEVEL_RESCUE_TEXT[13] = "cargo rescue";
const u8 LEVEL_TRADELANE_TEXT[11] = "trade lane";
const u8 LEVEL_HISTORICAL_STRUCTURES_TEXT[23] = "historical struectures";
const u8 LEVEL_SACRIFICE_TEXT[10] = "sacrifice";
const u8 LEVEL_MINED_HARBOUR_TEXT[14] = "mined harbour";
const u8 LEVEL_ESCORT_TEXT[7] = "escort";

extern u8* const levelNames[LEVEL_COUNT] =
{
    LEVEL_WILDLIFE_TEXT,
    LEVEL_GATED_TRADELANE_TEXT,
    LEVEL_RESCUE_TEXT,
    LEVEL_TRADELANE_TEXT,
    LEVEL_HISTORICAL_STRUCTURES_TEXT,
    LEVEL_SACRIFICE_TEXT,
    LEVEL_MINED_HARBOUR_TEXT,
    LEVEL_ESCORT_TEXT
};

void displayLevelHelp(u8 level)
{
    u8* memory = cpct_getScreenPtr(CPCT_VMEM_START, OBJECTIVES_X_, GRAPHIC_Y_);

    // Clear the screen before drawing text.
    cpct_clearScreen(0);

    drawString(TITLE_X_, TITLE_Y_, levelNames[level]);

    drawString(OBJECTIVES_X_, OBJECTIVES_Y_0, OBJECTIVE_TEXT);

    drawString(OBJECTIVES_X_, OBJECTIVES_Y_1, TIME_LIMIT_TEXT);

    if (level == LEVEL_WILDLIFE)
    {
        cpct_drawSprite(G_sea_creature_0, memory, TILE_WIDTH_BYTES, TILE_HEIGHT);

        drawString(OBJECTIVES_X_, OBJECTIVES_Y_2, CLEAR_MINES_TEXT);
        drawString(OBJECTIVES_X_, OBJECTIVES_Y_3, TURTLES_SAFE_TEXT);
    }
    else if (level == LEVEL_GATED_TRADELANE)
    {
        cpct_drawSprite(G_interactable_presure_plate_0, memory, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_interactable_gate_0, memory + 4, TILE_WIDTH_BYTES, TILE_HEIGHT);

        drawString(OBJECTIVES_X_, OBJECTIVES_Y_2, SHIPS_SAFE_TEXT);
    }
    else if (level == LEVEL_RESCUE)
    {
        cpct_drawSprite(G_interactable_platform_full, memory, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_unit_transport_ship_0a, memory + 4, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_unit_transport_ship_0b, memory + 8, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_unit_transport_ship_0c, memory + 12, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_interactable_platform_destination, memory + 16, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_unit_radar_ship_0a, memory + 21, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_unit_radar_ship_0b, memory + 25, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_unit_radar_ship_0c, memory + 29, TILE_WIDTH_BYTES, TILE_HEIGHT);
        
        drawString(OBJECTIVES_X_, OBJECTIVES_Y_2, SHIPS_SAFE_TEXT);
    }
    else if (level == LEVEL_TRADELANE)
    {
        // Got to clear the screen and draw the title again because the cargo ship is so big.
        cpct_clearScreen(0);

        cpct_drawSprite(G_ship_cargo_0aa, memory, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_cargo_0ab, memory + 4, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_cargo_0ac, memory + 8, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_cargo_0ad, memory + 12, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_cargo_0ae, memory + 16, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_cargo_0af, memory + 20, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_cargo_0ba, memory + 160, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_cargo_0bb, memory + 164, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_cargo_0bc, memory + 168, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_cargo_0bd, memory + 172, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_cargo_0be, memory + 176, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_cargo_0bf, memory + 180, TILE_WIDTH_BYTES, TILE_HEIGHT);
        
        drawString(TITLE_X_, TITLE_Y_, levelNames[level]);
        drawString(OBJECTIVES_X_, OBJECTIVES_Y_0 + 20, OBJECTIVE_TEXT);
        drawString(OBJECTIVES_X_, OBJECTIVES_Y_1 + 20, TIME_LIMIT_TEXT);
        drawString(OBJECTIVES_X_, OBJECTIVES_Y_2 + 20, SHIPS_SAFE_TEXT);
    }
    else if (level == LEVEL_HISTORICAL_STRUCTURES)
    {
        cpct_drawSprite(G_interactable_historical_wreck_0, memory, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_interactable_historical_wreck_1, memory + 4, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_interactable_historical_wreck_2, memory + 8, TILE_WIDTH_BYTES, TILE_HEIGHT);

        drawString(OBJECTIVES_X_, OBJECTIVES_Y_2, CLEAR_MINES_TEXT);
        drawString(OBJECTIVES_X_, OBJECTIVES_Y_3, STRUCTURES_SAFE_TEXT);
    }
    else if (level == LEVEL_SACRIFICE)
    {
        cpct_drawSprite(G_ship_warship_0a, memory, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_warship_0b, memory + 4, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_warship_0c, memory + 8, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_warship_0d, memory + 12, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_warship_0e, memory + 16, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_warship_0f, memory + 20, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_warship_0g, memory + 24, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_warship_0h, memory + 28, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_unit_kamikaze_0a, memory + 33, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_unit_kamikaze_0b, memory + 37, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_unit_kamikaze_0c, memory + 41, TILE_WIDTH_BYTES, TILE_HEIGHT);

        drawString(OBJECTIVES_X_, OBJECTIVES_Y_2, CLEAR_MINES_TEXT);
        drawString(OBJECTIVES_X_, OBJECTIVES_Y_3, SHIPS_SAFE_TEXT);
    }
    else if (level == LEVEL_MINED_HARBOUR)
    {
        cpct_drawSprite(G_ship_sail_0a, memory, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_sail_0b, memory + 4, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_sail_0c, memory + 8, TILE_WIDTH_BYTES, TILE_HEIGHT);

        drawString(OBJECTIVES_X_, OBJECTIVES_Y_2, CLEAR_MINES_TEXT);
        drawString(OBJECTIVES_X_, OBJECTIVES_Y_3, SHIPS_SAFE_TEXT);
    }
    else if (level == LEVEL_ESCORT)
    {
        cpct_drawSprite(G_ship_warship_0a, memory - 8, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_warship_0b, memory - 4, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_warship_0c, memory + 0, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_warship_0d, memory + 4, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_warship_0e, memory + 8, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_warship_0f, memory + 12, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_warship_0g, memory + 16, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_ship_warship_0h, memory + 20, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_unit_transport_ship_0a, memory + 25, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_unit_transport_ship_0b, memory + 29, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_unit_transport_ship_0c, memory + 33, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_interactable_platform_destination, memory + 37, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_unit_radar_ship_0a, memory + 42, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_unit_radar_ship_0b, memory + 46, TILE_WIDTH_BYTES, TILE_HEIGHT);
        cpct_drawSprite(G_unit_radar_ship_0c, memory + 50, TILE_WIDTH_BYTES, TILE_HEIGHT);

        drawString(OBJECTIVES_X_, OBJECTIVES_Y_2, SHIPS_SAFE_TEXT);
    }

    // Wait for any previous key presses to clear.
    while (cpct_isAnyKeyPressed());

    while (!cpct_isAnyKeyPressed());
}