#include "Link.h"

void logicLinks()
{
    u8 i = 0;

    // += 4 is for source and destination pairs.
    for (i = 0; i < level_links_array_size[currentLevel]; i += 4)
    {
        u8 sourceX = level_links[currentLevel][i];
        u8 sourceY = level_links[currentLevel][i + 1];
        u8 destinationX = level_links[currentLevel][i + 2];
        u8 destinationY = level_links[currentLevel][i + 3];
        u8 unitIndex = 0;

        // Passing unit as NULL as it is not relevent here.
        if (unitIndex = containsUnit(sourceX, sourceY, NULL))
        {
            // TODO improve support for other interatables.
            if (MAPA(destinationX, destinationY) == (CELL_INTERACTABLE_FLAG | INTERACTABLE_TYPE_GATE))
            {
                // Clearing the interactable due to the unit being over the pressure plate.
                MAPA(destinationX, destinationY) = 0;

                // Redraw the map after the link is changed.
                mapRedraw = TRUE;
            }
            else if (MAPA(sourceX, sourceY) == (CELL_INTERACTABLE_FLAG | INTERACTABLE_TYPE_PLATFORM_FULL))
            {
                // Transport ship can only pickup the cargo once.
                if (!units[unitIndex - 1].carryingCargo)
                {
                    // Change the intereactable to an empty platform on link being activated.
                    // Only a transport ship can move over a full platform so there doesn't have to be a unit check here.
                    MAPA(sourceX, sourceY) = CELL_INTERACTABLE_FLAG | INTERACTABLE_TYPE_PLATFORM_EMPTY;

                    // Update the transport ship to indicate that it is carrying cargo.
                    units[unitIndex - 1].carryingCargo = TRUE;

                    // Update the graphic index to change to the filled transport ship graphics.
                    units[unitIndex - 1].graphicIndex = UNIT_GRAPHIC_INDEX_FULL_TRANSPORT;
                }
            }
        }
        else if (unitIndex = containsUnit(destinationX, destinationY, NULL))
        {
            // Transport ship can only drop off the cargo if it is carrying it.
            if (units[unitIndex - 1].carryingCargo)
            {
                // Update the objectives on delivering the cargo.
                updateObjectives();

                // Empty cargo from ship.
                units[unitIndex - 1].carryingCargo = FALSE;

                // Update the graphic index to change to the empty transport ship graphics.
                units[unitIndex - 1].graphicIndex = UNIT_GRAPHIC_INDEX_EMPTY_TRANSPORT;
            }
        }
        else
        {
            // Deactivating the target interactable due to there being no unit over the pressure plate.
            if (MAPA(sourceX, sourceY) == (CELL_INTERACTABLE_FLAG | INTERACTABLE_TYPE_PRESSURE_PLATE) &&
                MAPA(destinationX, destinationY) == 0)
            {
                MAPA(destinationX, destinationY) = CELL_INTERACTABLE_FLAG | INTERACTABLE_TYPE_GATE;

                // Redraw the map after the link is changed.
                mapRedraw = TRUE;
            }
        }
    }
}