#ifndef MAP_H
#define MAP_H

#include <cpctelera.h>
#include "GameState.h"
#include "GameTypes.h"
#include "MapManager.h"
#include "Scrolling.h"
#include "sprites/ItemSprites.h"
#include "sprites/InteractableSprites.h"
#include "sprites/MineSprites.h"
#include "sprites/TileSprites.h"

extern u8 mapCells[MAP_CELL_COUNT];

// The mines for the current level.
extern u8 mapMines[MAX_MINE_ELEMENT_COUNT];

#define XY_TO_POSITION(x,y) x*MAP_TILES_Y + y
#define MAPA(x,y) mapCells[XY_TO_POSITION(x,y)]

// Draws the contents of the map on screen.
void drawMap();

// Draws a blank rectangle at the cell coordinates and takes into account scrolling.
void drawBlankCellScroll(u8 x, u8 y);

// Draws the content of a cell from the map on screen.
void drawCell(u8 x, u8 y, u8 cell);

// Draws the mine on the screen using the specific memory location.
void drawMine(u8 mine, u8* memory);

// For finding a mine at position x,y.
u16 findMine(u8 x, u8 y);

// Initialises the map grid.
void initMap(u8 mapNumber);

#endif