#include "MapManager.h"

u8* const level_links[LEVEL_COUNT] =
{
    NULL,
    map_GatedTradeLane_links,
    map_Rescue_links,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL
};

const u8 level_links_array_size[LEVEL_COUNT] =
{
    0,
    MAP_GATEDTRADELANE_LINK_ARRAY_SIZE,
    MAP_RESCUE_LINK_ARRAY_SIZE,
    0,
    0,
    0,
    0,
    0
};

u8* const level_map[LEVEL_COUNT] = 
{
    map_Wildlife_compressed,
    map_GatedTradeLane_compressed,
    map_Rescue_compressed,
    map_TradeLane_compressed,
    map_HistoricalStructures_compressed,
    map_Sacrifice_compressed,
    map_MinedHarbour_compressed,
    map_Escort_compressed
};

const u16 level_map_size[LEVEL_COUNT] = 
{
    MAP_WILDLIFE_COMPRESSED_SIZE,
    MAP_GATEDTRADELANE_COMPRESSED_SIZE,
    MAP_RESCUE_COMPRESSED_SIZE,
    MAP_TRADELANE_COMPRESSED_SIZE,
    MAP_HISTORICALSTRUCTURES_COMPRESSED_SIZE,
    MAP_SACRIFICE_COMPRESSED_SIZE,
    MAP_MINEDHARBOUR_COMPRESSED_SIZE,
    MAP_ESCORT_COMPRESSED_SIZE
};

const u8 level_mine_count[LEVEL_COUNT] =
{
    MAP_WILDLIFE_MINE_COUNT,
    MAP_GATEDTRADELANE_MINE_COUNT,
    MAP_RESCUE_MINE_COUNT,
    MAP_TRADELANE_MINE_COUNT,
    MAP_HISTORICALSTRUCTURES_MINE_COUNT,
    MAP_SACRIFICE_MINE_COUNT,
    MAP_MINEDHARBOUR_MINE_COUNT,
    MAP_ESCORT_MINE_COUNT
};

u8* const level_mines[LEVEL_COUNT] =
{
    mines_Wildlife,
    mines_GatedTradeLane,
    mines_Rescue,
    mines_TradeLane,
    mines_HistoricalStructures,
    mines_Sacrifice,
    mines_MinedHarbour,
    mines_Escort
};

const u16 level_mines_array_size[LEVEL_COUNT] =
{
    MAP_WILDLIFE_MINE_ARRAY_SIZE,
    MAP_GATEDTRADELANE_MINE_ARRAY_SIZE,
    MAP_RESCUE_MINE_ARRAY_SIZE,
    MAP_TRADELANE_MINE_ARRAY_SIZE,
    MAP_HISTORICALSTRUCTURES_MINE_ARRAY_SIZE,
    MAP_SACRIFICE_MINE_ARRAY_SIZE,
    MAP_MINEDHARBOUR_MINE_ARRAY_SIZE,
    MAP_ESCORT_MINE_ARRAY_SIZE
};

u8* const level_ship[LEVEL_COUNT] =
{
    ships_Wildlife,
    ships_GatedTradeLane,
    NULL,
    ships_TradeLane,
    NULL,
    ships_Sacrifice,
    ships_MinedHarbour,
    ships_Escort
};

const u8 level_ship_array_size[LEVEL_COUNT] =
{
    MAP_WILDLIFE_SHIP_ARRAY_SIZE,
    MAP_GATEDTRADELANE_SHIP_ARRAY_SIZE,
    0,
    MAP_TRADELANE_SHIP_ARRAY_SIZE,
    0,
    MAP_SACRIFICE_SHIP_ARRAY_SIZE,
    MAP_MINEDHARBOUR_SHIP_ARRAY_SIZE,
    MAP_ESCORT_SHIP_ARRAY_SIZE
};

u8* const level_target[LEVEL_COUNT] =
{
    NULL, 
    map_GatedTradeLane_targets,
    NULL, 
    map_TradeLane_targets,
    NULL, 
    map_Sacrifice_targets,
    map_MinedHarbour_targets,
    NULL
};

const u8 level_target_array_size[LEVEL_COUNT] =
{
    0,
    MAP_GATEDTRADELANE_TARGET_ARRAY_SIZE,
    0,
    MAP_TRADELANE_TARGET_ARRAY_SIZE,
    0,
    MAP_SACRIFICE_TARGET_ARRAY_SIZE,
    MAP_MINEDHARBOUR_TARGET_ARRAY_SIZE,
    0
};

const u16 level_turns[LEVEL_COUNT] =
{
    300,
    500,
    750,
    222,
    500,
    200,
    400,
    250
};

u8* const level_zone[LEVEL_COUNT] =
{
    zone_Wildlife,
    zone_GatedTradeLane,
    zone_Rescue,
    zone_TradeLane,
    zone_HistoricalStructures,
    zone_Sacrifice,
    zone_MinedHarbour,
    zone_Escort
};
