#ifndef MAPMANAGER_H
#define MAPMANAGER_H

#include <types.h>
#include "GameTypes.h"
#include "maps/Escort.h"
#include "maps/GatedTradeLane.h"
#include "maps/HistoricalStructures.h"
#include "maps/MinedHarbour.h"
#include "maps/Rescue.h"
#include "maps/Sacrifice.h"
#include "maps/TradeLane.h"
#include "maps/Wildlife.h"

#define LEVEL_COUNT 8

#define LEVEL_WILDLIFE 0
#define LEVEL_GATED_TRADELANE 1
#define LEVEL_RESCUE 2
#define LEVEL_TRADELANE 3
#define LEVEL_HISTORICAL_STRUCTURES 4
#define LEVEL_SACRIFICE 5
#define LEVEL_MINED_HARBOUR 6
#define LEVEL_ESCORT 7

// Pointer to the ships array for the current level.
extern u8* currentLevelShips;

// The number of elements in the current level ship array.
extern u8 currentLeveShipArraySize;

// Pointer to the targets array for the current level.
extern u8* currentLevelTargets;

// Level link array pointers.
extern u8* const level_links[LEVEL_COUNT];

// The number of elements in the level link array.
extern const u8 level_links_array_size[LEVEL_COUNT];

// Level map array pointers.
extern u8* const level_map[LEVEL_COUNT];

// The size of the map arrays.
extern const u16 level_map_size[LEVEL_COUNT];

// The number of mines in the level.
extern const u8 level_mine_count[LEVEL_COUNT];

// Level mine array pointers.
extern u8* const level_mines[LEVEL_COUNT];

// The number of elements in the level mine array.
extern const u16 level_mines_array_size[LEVEL_COUNT];

// Level ship array pointers.
extern u8* const level_ship[LEVEL_COUNT];

// The number of elements in the level ship array.
extern const u8 level_ship_array_size[LEVEL_COUNT];

// The state of the levels and whether they are available or complete or not.
extern u8 levelStates[LEVEL_COUNT];

// Level target array pointers.
extern u8* const level_target[LEVEL_COUNT];

// The number of elements in the level target array.
extern const u8 level_target_array_size[LEVEL_COUNT];

// The number of  turns in the level.
extern const u16 level_turns[LEVEL_COUNT];

// Level zone array pointers.
extern u8* const level_zone[LEVEL_COUNT];

#endif