#ifndef MENU_H
#define MENU_H

#include "Difficulty.h"
#include "Game.h"
#include "GameState.h"
#include "Keys.h"
#include "Text.h"
#include "Palette.h"

// Choose the level of difficulty for the game session.
void chooseDifficulty();

// Displays either victorious or game over depending on if the user completes the game or not.
void displayEndScreen();

// Displays the current high scores on the screen in a list.
void displayHighScores();

// Draws the main menu on screen.
void drawMenu();

// Get key function for rebind/redefine key controls by ranaldo.
cpct_keyID getKey();

// Initialise the high score values.
void initHighScores();

// Allows the user to choose the keyboard/joystick controls for the game.
void rebindControls();

// Sets up the main menu and runs the menu loop.
void runMenu();

// Switch between a GT64 friendly palette and normal colourful palette.
void switchColourMode();

// Update the high scores if the player has a high score.
void updateHighScores();

#endif