#ifndef OBJECTIVES_H
#define OBJECTIVES_H

#include <types.h>
#include "Difficulty.h"
#include "GameState.h"
#include "GameTypes.h"
#include "MapManager.h"
#include "Unit.h"

// The number of historical structure cells that have been destroyed.
extern u8 destroyedStructures;

// The number of turtles that have been killed during the level.
extern u8 turtlesKilled;

// Check if the player has completed the objectives for the level.
u8 checkObjectives();

// Sets up the end of the game due to some condition of failure being met.
u8 failObjectives();

// Initialise the objectives for the current level so they can be completed once the player achieves them.
void initObjectives();

// Updates the objective values that will be used to determine if the objectives have been completed.
void updateObjectives();

#endif