#ifndef PLAYER_H
#define PLAYER_H

#include <cpctelera.h>
#include "GameState.h"
#include "GameTypes.h"
#include "Hud.h"
#include "Keys.h"
#include "Map.h"
#include "Scrolling.h"
#include "Unit.h"
#include "UnitManager.h"
#include "sprites/MiscSprites.h"
#include "sprites/UnitSprites.h"

// Redraws the cell at the current position of the cursor.
void clearIndicator();

// Draw the cursor on the screen.
void drawCursor(u8 xScroll, u8 yScroll);

// Draws the player's units on the screen.
void drawUnits();

// Initialises the player logic.
void initPlayer();

// Moves the cursor around the screen one cell at a time.
void moveCursor();

// Executes the player logic.
void playerLogic();

#endif