#include "Ship.h"

void initShips()
{
    u8 i = 0;

    // Start at the friendly ship position of the unit array.
    Unit* unit = units + FRIENDLY_SHIP_UNIT_START;

    // Point current level ship to the start of the current level ships array.
    u8* currentLevelShip = currentLevelShips;

    // Retrieve the ship count from the ship array size for the level.
    friendlyShipCount = currentLeveShipArraySize / 5;

    for (i = 0; i < currentLeveShipArraySize; i += 5)
    {
        // Add a non player ship to the units array.
        unit->position.x = *currentLevelShip++;
        unit->position.y = *currentLevelShip++;
        unit->type = *currentLevelShip;
        unit->width = shipWidth(*currentLevelShip);
        unit->height = shipHeight(*currentLevelShip++);
        unit->health = 10;

        if (unit->type == UNIT_TYPE_TURTLE)
        {
            unit->unitClass = MARINE_LIFE_UNIT_CLASS;
        }
        else
        {
            unit->unitClass = SHIP_UNIT_CLASS;
        }

        // Set target values from ship array.
        unit->targetStartIndex = *currentLevelShip++;
        unit->targetEndIndex = *currentLevelShip;

        // Set target x and y if the unit has a target in the target array
        if (unit->targetStartIndex != 255)
        {
            unit->target.x = currentLevelTargets[unit->targetStartIndex];
            unit->target.y = currentLevelTargets[unit->targetStartIndex + 1];
        }

        // Move to the next unit in the unit array.
        ++unit;

        // Move to the next element in the current level ships array.
        ++currentLevelShip;
    }
}